Unit
  Graph2;


INTERFACE


Uses
  Graph,Crt;


Const
  DrivePath = 'c:\tp\bgi';
{  DrivePath = 'c:\langs\tp\bgi';}


Type
  TFajlKomp = Record   {fajl-komponens: az elmentett kepernyo egy sora}
    Hossz : Word;        {bajtsorozat hossza}
    X1,Y1 : Integer;     {kimentes/visszarajzolas bal felso sarka}
    Tar   : Array[1..350] of Byte; {az elmentett kepernyo egy sora}
  end{record};

  TEScreen = Record
    SorokSzama : Word;       {a fajlban az egymas utan elmentett sorok szama}
    FajlNev    : String[12]; {Fajlnev (*.tmp). A RandomFajlNev allitja elo.}
  end{record};

  AblakTulTip = Object
      X1,Y1,X2,Y2   : Integer;    {ablakpoziciok: bal also, jobb felso sarok}
      FejlecHSzin   : Word;       {fejlec hatterszine}
      FejlecSzSzin  : Word;       {fejlec szovegenek szine}
      FejLecSzov    : String[50]; {fejlec szovege}
      MunkaTerHSzin : Word;       {munkaterulet hatterszine}
      VanEKeret     : Boolean;    {Van-e az ablaknak kerete}
      VanEFejlec    : Boolean;    {Van-e az ablaknak fejlece}
      Procedure Rajz;           {ablak megrajzolasa, elozo ablak adatainak elmentese}
      Procedure Elmentes;       {mogotte levo ablak elmentese a heap-ba}
      Procedure Be;             {munkaterulet ablakpozicioinak beallitasa}
      Procedure Ki;             {elozo ablak adatainak visszaallitasa}
      Procedure Visszatoltes;   {mogotte levo ablak visszatoltese a heap-bol}
      Function TeljesSzel:Integer;
      Function MunkaTerSzel:Integer;
      Function TeljesMag:Integer;
      Function MunkaTerMag:Integer;
      Procedure ClrScr;

    Private
      FejLecMag       : Byte;          {fejlec magassaga}
      EA              : ViewPortType;  {elozo ablak-poziciok adatai}
      ERajzSzin       : Word;          {elozo rajzolo szin}
      EScreen         : TEScreen;      {elmentett ablak adatai}
      TX1,TY1,TX2,TY2 : Integer;  {teljes ablak poziciok}
    end{Object};

  TTovabb = (Le, Fel, Jobbra, Balra, Kilep, Semmi);

  {kurzormozgatoval valtoztathato erteku beviteli mezo egesz tipusra}
  ScEditEgesz = Object
    Public
      Felirat       : String[20];

      In_Out        : Longint;  {bemeneti es kimeneti tar}
      MinErt        : Longint;  {minimalisan felveheto ertek}
      MaxErt        : Longint;  {maximalisan felveheto ertek}
      LepesKoz      : Longint;     {a kurzormozgato egyszeri lenyomasara mennyit lep}
      NagyLepesKoz  : Longint;     {a PageUp/Down egyszeri lenyomasara mennyit lep}

      X1,Y1         : Integer;  {ablakpoziciok: bal also sarok}
      AktHSzin      : Word;     {aktiv allapot hatter szine}
      AktRajzSzin   : Word;     {aktiv allapot rajzolo szine}
      PasszHSzin    : Word;     {passziv allapot hatter szine}
      PasszRajzSzin : Word;     {passziv allapot rajzolo szine}
      VanEKeret     : Boolean;  {van-e keret}
      HatarSavSzel  : Byte;     {rajzolo terulet korulotti ures terulet}
(*      BetuTipus     : Word;     {kiiras betutipusa}
      BetuNagysag   : Word;     {kiiras betunagysaga}*)
  {azert nem celszeru hasznalni, mert nem tudom igy meghatarozni
   a szukseges szelesseget es magassagot}

      Tovabb        : TTovabb;
      Procedure View;
      Procedure Edit;
      Function Magassag:Integer;{beviteli mezo magassaga}
      Function MezoSzelesseg:Integer;{beviteli mezo szelessege}
      Function TeljesSzelesseg:Integer;{beviteli mezo szelessege felirattal egyutt}

    Private
      AktErt : Longint;  {az aktualis ertek}
  end{object};


Var
  WinMaxX : Integer;
  WinMaxY : Integer;


Function YFordit(Y:Integer):Integer;
                       {bal also, jobb felso sarok koordinatai}
Procedure SetViewPort2(X1,Y1,X2,Y2:Integer; Clip:Boolean);
Procedure GetViewSettings2(var ViewPort:ViewPortType);

Procedure Arc2(X,Y:Integer; StAngle,EndAngle,Radius:Word);
Procedure Bar2(X1,Y1,X2,Y2:Integer);
Procedure Bar3D2(X1,Y1,X2,Y2:Integer;Depth:Word;Top:Boolean);
Procedure Circle2(X,Y:Integer; Radius:Word);
Procedure MoveTo2(X,Y:Integer);
Procedure ClearDevice2;
Procedure ClearViewPort2;
Function GetY2:Integer;
Procedure Line2(X1,Y1,X2,Y2:Integer);
Procedure LineRel2(Dx,Dy:Integer);
Procedure LineTo2(X,Y:Integer);
Procedure MoveRel2(Dx,Dy:Integer);
Procedure OutText2(TextString:String);
Procedure OutTextXY2(X,Y:Integer; TextString:String);
Procedure Rectangle2(X1,Y1,X2,Y2:Integer);
Procedure PutPixel2(X,Y:Integer;Pixel:Word);


IMPLEMENTATION


Procedure GraphBekapcs;
var
  Gd,Gm : Integer;
 begin
   DetectGraph(Gd,Gm);
   InitGraph(Gd,Gm,DrivePath);
 end{GraphBekapcs};


Procedure ClearViewPort2;
 begin
   Bar2(0,0,WinMaxX,WinMaxY);
   MoveTo2(0,0);
 end{KepernyoTorles};


Function YFordit(Y:Integer):Integer;
 begin
   YFordit:=WinMaxY-Y;
 end{YFordit};

{bal also (1), es jobb felso (2) sarok koordinatai}
Procedure SetViewPort2(X1,Y1,X2,Y2:Integer; Clip:Boolean);
 begin
   SetViewPort(X1,GetMaxY-Y2,X2,GetMaxY-Y1,Clip);
   WinMaxX:=abs(X2-X1);
   WinMaxY:=abs(Y2-Y1);
 end{SetViewPort2};


Procedure GetViewSettings2(var ViewPort:ViewPortType);
 begin
   GetViewSettings(ViewPort);
   ViewPort.Y2:=GetMaxY-ViewPort.Y1;
   ViewPort.Y2:=GetMaxY-ViewPort.Y2;
 end{GetViewSettings2};


Procedure Arc2(X,Y:Integer; StAngle,EndAngle,Radius:Word);
 begin
   Arc(X,YFordit(Y),StAngle,EndAngle,Radius);
 end{Arc2};


Procedure Bar2(X1,Y1,X2,Y2:Integer);
 begin
   Bar(X1,YFordit(Y2),X2,YFordit(Y1));
 end{Bar2};


Procedure Bar3D2(X1,Y1,X2,Y2:Integer;Depth:Word;Top:Boolean);
 begin
   Bar3D(X1,YFordit(Y2),X2,YFordit(Y1),Depth,Top);
 end{Bar2};


Procedure Circle2(X,Y:Integer; Radius:Word);
 begin
   Circle(X,YFordit(Y),Radius);
 end{Circle2};


Procedure MoveTo2(X,Y:Integer);
 begin
   MoveTo(X,YFordit(Y));
 end{MoveTo2};


Procedure ClearDevice2;
 begin
   ClearDevice;
   MoveTo2(0,0);
 end;


Function GetY2:Integer;
 var
   Sv : Integer;
 begin
   Sv:=GetY;
   Sv:=YFordit(Sv);
 end{GetY};


Procedure Line2(X1,Y1,X2,Y2:Integer);
 begin
   Line(X1,YFordit(Y1),X2,YFordit(Y2));
 end{Line2};


Procedure LineRel2(Dx,Dy:Integer);
 begin
   LineRel(Dx,-Dy);
 end{LineRel2};


Procedure LineTo2(X,Y:Integer);
 begin
   LineTo(X,YFordit(Y));
 end{LineTo2};


Procedure MoveRel2(Dx,Dy:Integer);
 begin
   MoveRel(Dx,-Dy);
 end{MoveRel2};


Procedure OutText2(TextString:String);
 var
   Mag : Integer;
   Y   : Integer;
 begin
   Mag:=TextHeight(TextString);
   Y:=YFordit(GetY)+Mag;
   MoveTo2(GetX,Y);
   OutText(TextString);
 end{OutText2};


Procedure OutTextXY2(X,Y:Integer; TextString:String);
 var
   Mag : Integer;
 begin
   Mag:=TextHeight(TextString);
   OutTextXY(X,YFordit(Y)-Mag,TextString);
 end{OutTextXY2};


Procedure Rectangle2(X1,Y1,X2,Y2:Integer);
 begin
   Rectangle(X1,YFordit(Y1),X2,YFordit(Y2));
 end{Rectangle2};


Procedure PutPixel2(X,Y:Integer;Pixel:Word);
 begin
   PutPixel(X,YFordit(Y),Pixel);
 end{PutPixel2};


Procedure AblakTulTip.Rajz;
 var
   FillInfo : FillSettingsType;
 begin
   {Megelozo adatok elmentese:}
     GetViewSettings(EA);
     ERajzSzin:=GetColor;
   FejlecMag:=17;
   SetViewPort2(X1, Y1, X2, Y2, True);

   GetFillSettings(FillInfo);
   {munkaterulet hatterszine}
     SetFillStyle(1,MunkaTerHSzin);   Bar2(0,0,WinMaxX,WinMaxY);
   {fejlec hatterszine}
     If VanEFejlec Then
       begin
         SetFillStyle(1,FejlecHSzin);
         Bar2(0,WinMaxY-FejlecMag,WinMaxX,WinMaxY);
       end{then};
     SetFillStyle(FillInfo.Pattern,FillInfo.Color);
   {keretek:}
     If VanEKeret Then
       begin
         Line2(0,0,0,WinMaxY); Line2(0,0,WinMaxX,0); Line2(WinMaxX,0,WinMaxX,WinMaxY); Line2(WinMaxX,WinMaxY,0,WinMaxY);
         If VanEFejlec Then Line2(0,WinMaxY-FejlecMag,WinMaxX,WinMaxY-FejLecMag);
       end{then};
   {felirat:}
     If VanEFejlec Then
       begin
         SetColor(FejlecSzSzin);
         OutTextXY2((WinMaxX Div 2) - (TextWidth(FejlecSzov) Div 2),WinMaxY-FejlecMag+3,FejlecSzov);
       end{then};

   {elmentett adatok visszaallitasa:}
     SetViewPort(EA.X1,EA.Y1,EA.X2,EA.Y2,EA.Clip);
     SetColor(ERajzSzin);
 end{AblakTulTip.Rajz};


Procedure AblakTulTip.Be;
 begin
   {munkaterulet pozicioinak beallitasa:}
     If VanEKeret Then
       begin
         Inc(X1); Inc(Y1); Dec(X2); Dec(Y2);
       end{then};
     If VanEFejlec Then Y2:=Y2-FejlecMag;
   SetViewPort2(X1, Y1, X2, Y2, True);{munkaterulet}
 end{AblakTulTip.Be};


Procedure AblakTulTip.Ki;
 begin
   SetViewPort(EA.X1,EA.Y1,EA.X2,EA.Y2,EA.Clip);{Elmentett ablak-poziciok visszaallitasa}
   {ablak-poziciok visszalltsa:}
     If VanEKeret Then
       begin
         Dec(X1); Dec(Y1); Inc(X2); Inc(Y2);
       end{then};
     If VanEFejlec Then Y2:=Y2+FejlecMag;
 end{AblakTulTip.Ki};


Function RandomFajlNev:String;
   var
     Szam    : Byte;
     Betu    : Char;
     FajlN : String[12];
     i       : Byte;
   begin
     Randomize;
     i:=0;
     Repeat
       Inc(i);
       Szam:=Random(25+1);
       Betu:=Chr(Szam+97);
       FajlN[0]:=Chr(i);
       FajlN[i]:=Betu;
     Until i=8;
     RandomFajlNev:=FajlN+'.tmp';
   end{FajlNev};


Procedure AblakTulTip.Elmentes;
 var
   i          : Word;
   WriteFajl  : File of TFajlKomp;
   FajlKomp   : TFajlKomp;  {fajl-komponens: az elmentett kepernyo egy sora}
   EAPoz      : ViewPortType;
 begin{Elmentes};
   GetViewSettings(EAPoz);   SetViewPort(0,0,GetMaxX,GetMaxY,True); {ablak maximalizalasa}

   TX1:=X1;   TY1:=Y1;   TX2:=X2;   TY2:=Y2;
   EScreen.FajlNev:=RandomFajlNev;
     Assign(WriteFajl,EScreen.FajlNev);
     ReWrite(WriteFajl);
   EScreen.SorokSzama:=Abs(TY2-TY1)+1;
   i:=0;
   Repeat     {lentrol felfele halad!!!}
     Inc(i);
     FajlKomp.Hossz:=ImageSize(TX1, 479-TY1-(i-1), TX2, 479-TY1-(i-1));
{}     If FajlKomp.Hossz>350 Then Halt;  {}
     FajlKomp.X1:=TX1;
     FajlKomp.Y1:=479-TY1-(i-1);
     GetImage(TX1, 479-TY1-(i-1), TX2, 479-TY1-(i-1), FajlKomp.Tar);
     Write(WriteFajl,FajlKomp);
   Until i=EScreen.SorokSzama;
   Close(WriteFajl);
   SetViewPort(EAPoz.X1,EAPoz.Y1,EAPoz.X2,EAPoz.Y2,True);
 end{AblakTulTip.Elmentes};


Procedure AblakTulTip.Visszatoltes;
 var
   i        : Word;
   ReadFajl : File of TFajlKomp;
   FajlKomp : TFajlKomp;  {fajl-komponens: az elmentett kepernyo egy sora}
   EAPoz    : ViewPortType;
 begin
   GetViewSettings(EAPoz);   SetViewPort(0,0,GetMaxX,GetMaxY,True); {ablak maximalizalasa}

   Assign(ReadFajl,EScreen.FajlNev);
   Reset(ReadFajl);
   i:=0;
   Repeat     {lentrol felfele halad!!!}
     Inc(i);
     Read(ReadFajl,FajlKomp);
     PutImage(FajlKomp.X1, FajlKomp.Y1, FajlKomp.Tar, NormalPut);
   Until i=EScreen.SorokSzama;
   Close(ReadFajl);
   Erase(ReadFajl);
   SetViewPort(EAPoz.X1,EAPoz.Y1,EAPoz.X2,EAPoz.Y2,True);{elozo ablak pozicioinak visszaallitasa}
 end{AblakTulTip.Visszatoltes};


Function AblakTulTip.TeljesSzel:Integer;
 begin
   TeljesSzel:=Abs(TX2-TX1);
 end{AblakTulTip.TeljesSzel};


Function AblakTulTip.MunkaTerSzel:Integer;
 begin
   MunkaTerSzel:=Abs(X2-X1);
 end{AblakTulTip.MunkaTerSzel};


Function AblakTulTip.TeljesMag:Integer;
 begin
   TeljesMag:=Abs(TY2-TY1);
 end{AblakTulTip.TeljesMag};


Function AblakTulTip.MunkaTerMag:Integer;
 begin
   MunkaTerMag:=Abs(Y2-Y1);
 end{AblakTulTip.MunkaTerMag};


Function ScEditEgesz.Magassag:Integer;
 var
   TextInfo  : TextSettingsType;
   Mag       : Integer;
   Szov      : String[50];
 begin
   GetTextSettings(TextInfo);{elozo szovegjellemzok elmentese}
(*     SetTextStyle(Betutipus,BetuNagysag,0);{az uj beallitasa}*)

   Str(In_Out,Szov);
   Mag:=TextHeight(Szov);
   If VanEKeret Then Mag:=Mag+2;
   Mag:=Mag+(HatarSavSzel*2);
   SetTextStyle(TextInfo.Font,TextInfo.Direction,TextInfo.CharSize);{elozo szovegjellemzok visszaallitasa}
   Magassag:=Mag;
 end{ScEditEgesz.Magassag};


Function ScEditEgesz.MezoSzelesseg:Integer;
 var
   TextInfo  : TextSettingsType;
   Szel      : Integer;
   Szov      : String[50];
 begin
   GetTextSettings(TextInfo);{elozo szovegjellemzok elmentese}
(*     SetTextStyle(Betutipus,BetuNagysag,0);{az uj beallitasa}*)

   Str(MaxErt,Szov);
   Szel:=TextWidth(Szov);
   If VanEKeret Then Szel:=Szel+2;
   Szel:=Szel+(HatarSavSzel*2);
   SetTextStyle(TextInfo.Font,TextInfo.Direction,TextInfo.CharSize);{elozo szovegjellemzok visszaallitasa}
   MezoSzelesseg:=Szel;
 end{ScEditEgesz.MezoSzelesseg};


Function ScEditEgesz.TeljesSzelesseg:Integer;
 var
   TextInfo  : TextSettingsType;
   Szel      : Integer;
   Szov      : String[50];
 begin
   GetTextSettings(TextInfo);{elozo szovegjellemzok elmentese}
(*     SetTextStyle(Betutipus,BetuNagysag,0);{az uj beallitasa}*)

   Szel:=MezoSzelesseg+HatarSavSzel; {a mezo es a feriat kozott}
   Szel:=Szel+TextWidth(Felirat);

   SetTextStyle(TextInfo.Font,TextInfo.Direction,TextInfo.CharSize);{elozo szovegjellemzok visszaallitasa}
   TeljesSzelesseg:=Szel;
 end{ScEditEgesz.TeljesSzelesseg};


Procedure ScEditEgesz.View;
 var
   EAPoz     : ViewPortType;
   FillInfo  : FillSettingsType;
   ERajzSzin : Word;
   TextInfo  : TextSettingsType;
   Szov      : String;
 begin
   If In_Out<MinErt Then In_Out:=MinErt;
   If In_Out>MaxErt Then In_Out:=MaxErt;
   {ELOZO BEALLITASOK ELMENTESE, AZ UJAK BEALLITASA:}
   GetViewSettings(EAPoz);{elozo ablak pozicioinak elmentese}
     SetViewPort2(X1+(TeljesSzelesseg-MezoSzelesseg),Y1,X1+TeljesSzelesseg,Y1+Magassag,True);{az uj betoltese}
   GetFillSettings(FillInfo);{elozo kitoltese beallitasok elmentese}
     SetFillStyle(1,PasszHSzin);    {az uj betoltese}
     Bar2(0,0,WinMaxX,WinMaxY);
   ERajzSzin:=GetColor;{elozo rajzszin elmentese}
     SetColor(PasszRajzSzin);{az uj betoltese}
   GetTextSettings(TextInfo);{elozo szovegjellemzok elmentese}
(*     SetTextStyle(Betutipus,BetuNagysag,0);{az uj beallitasa}*)

   {keretek:}
   If VanEKeret Then
     begin
       Line2(0,0,0,WinMaxY);
       Line2(0,WinMaxY,WinMaxX,WinMaxY);
       Line2(WinMaxX,WinMaxY,WinMaxX,0);
       Line2(WinMaxX,0,0,0);
     end{then};

   {kiiras:}
   SetViewPort2(X1+HatarSavSzel,Y1+HatarSavSzel,X1+TeljesSzelesseg-HatarSavSzel,Y1+Magassag-HatarSavSzel,True);
   OutTextXY2(0,0,Felirat);
   Str(In_Out,Szov);
   OutTextXY2(TeljesSzelesseg-MezoSzelesseg,0,Szov);

   {ELOZO BEALLITASOK VISSZAALLITASA:}
   SetViewPort(EAPoz.X1,EAPoz.Y1,EAPoz.X2,EAPoz.Y2,True);{elozo ablak pozicioinak visszaallitasa}
   SetFillStyle(FillInfo.Pattern,FillInfo.Color);{elozo kitoltesi beallitasok visszaallitasa}
   SetColor(ERajzSzin);{elozo rajzszin visszaallitasa}
   SetTextStyle(TextInfo.Font,TextInfo.Direction,TextInfo.CharSize);{elozo szovegjellemzok visszaallitasa}
 end;{ScrollEdit.View}


Procedure ScEditEgesz.Edit;
 var
   EAPoz     : ViewPortType;
   FillInfo  : FillSettingsType;
   ERajzSzin : Word;
   TextInfo  : TextSettingsType;
   Bill      : Char;
   Szov      : String[50];
 begin
   {ELOZO BEALLITASOK ELMENTESE, AZ UJAK BEALLITASA:}
   GetViewSettings(EAPoz);{elozo ablak pozicioinak elmentese}
     If VanEKeret Then
       SetViewPort2(X1+(TeljesSzelesseg-MezoSzelesseg)+HatarSavSzel-1+1,
                    Y1+HatarSavSzel-1+1,
                    X1+TeljesSzelesseg-HatarSavSzel-1,
                    Y1+Magassag-HatarSavSzel-1,
                    True)
     Else
       SetViewPort2(X1+(TeljesSzelesseg-MezoSzelesseg)+HatarSavSzel-1,
                    Y1+HatarSavSzel-1,
                    X1+TeljesSzelesseg-HatarSavSzel,
                    Y1+Magassag-HatarSavSzel,
                    True);
   GetFillSettings(FillInfo);{elozo kitoltese beallitasok elmentese}
     SetFillStyle(0,AktHSzin);    {az uj betoltese}
     Bar2(0,0,WinMaxX,WinMaxY);
   ERajzSzin:=GetColor;{elozo rajzszin elmentese}
     SetColor(AktRajzSzin);{az uj betoltese}
   Str(In_Out,Szov);
   OutTextXY2(0,0,Szov);

   GetTextSettings(TextInfo);{elozo szovegjellemzok elmentese}
(*     SetTextStyle(Betutipus,BetuNagysag,0);{az uj beallitasa}*)

   AktErt:=In_Out;
   Bill:=ReadKey;
   If Bill=Chr(0) Then
     begin
       Bill:=ReadKey;
       Case Bill of
         Chr(72) : begin {fel} {inkrementalas}
                     If AktErt<MaxErt Then Inc(AktErt);
                     Tovabb:=Semmi;
                   end;
         Chr(80) : begin {le} {dekrementalas}
                     If AktErt>MinErt Then Dec(AktErt);
                     Tovabb:=Semmi;
                   end;
         Chr(15) : Tovabb:=Fel; {shift+tab} {ugras az elozore ertekvaltoztatas nelkul}
         Chr(73) : begin {PgUp} {nagylepeskoz felfele}
                     If AktErt+NagyLepesKoz>MaxErt Then
                       AktErt:=MaxErt
                     Else
                       AktErt:=AktErt+NagyLepesKoz;
                     Tovabb:=Semmi;
                   end;
         Chr(81) : begin {PgDn} {nagylepeskoz lefele}
                     If AktErt-NagyLepesKoz<MinErt Then
                       AktErt:=MinErt
                     Else
                       AktErt:=AktErt-NagyLepesKoz;
                     Tovabb:=Semmi;
                   end;
         Chr(71) : begin {Home} {maximalis ertek}
                     AktErt:=MaxErt;
                     Tovabb:=Semmi;
                   end;
         Chr(79) : begin {End} {minimalis ertek}
                     AktErt:=MinErt;
                     Tovabb:=Semmi;
                   end;
         {PgDn}{minimalis ertek}
       end{case};
     end{then}
   Else
     Case Bill of
       Chr(9)  : Tovabb:=Le; {tab} {ugras a kovetkezore ertekvaltoztatas nelkul}
       Chr(27) : Tovabb:=Kilep; {escape} {helybenmaradas ertekvaltoztatas nelkul}
       Chr(13) : Tovabb:=Kilep; {enter} {helybenmaradas ertekvaltoztatas nelkul}
     end{case};

   Bar2(0,0,WinMaxX,WinMaxY);
   In_Out:=AktErt;
   Str(In_Out,Szov);
   OutTextXY2(0,0,Szov);

   {ELOZO BEALLITASOK VISSZAALLITASA:}
   SetViewPort(EAPoz.X1,EAPoz.Y1,EAPoz.X2,EAPoz.Y2,True);{elozo ablak pozicioinak visszaallitasa}
   SetFillStyle(FillInfo.Pattern,FillInfo.Color);{elozo kitoltesi beallitasok visszaallitasa}
   SetColor(ERajzSzin);{elozo rajzszin visszaallitasa}
   SetTextStyle(TextInfo.Font,TextInfo.Direction,TextInfo.CharSize);{elozo szovegjellemzok visszaallitasa}
 end;{ScrollEdit.Edit}


Procedure AblakTulTip.ClrScr;
  var
    FillInfo  : FillSettingsType;
  begin
    GetFillSettings(FillInfo);{elozo kitoltese beallitasok elmentese}
    SetFillStyle(1,MunkaTerHSzin);    {az uj betoltese}
      Bar2(0,0,WinMaxX,WinMaxY);
    SetFillStyle(FillInfo.Pattern,FillInfo.Color);{elozo kitoltesi beallitasok visszaallitasa}
  end;


Begin
  GraphBekapcs;
  ClearViewPort2;
  WinMaxX:=GetMaxX;
  WinMaxY:=GetMaxY;
End.