Unit
  Menu;


INTERFACE

Uses
  Crt,Graph,Graph2;

Const
  MaxSzam = 30;

Type
 TMenuPont = Record
   Cimke          : String;  {Menupont kiirando cimkeje}
   AktivE         : Boolean; {Az adott menupont aktiv allapotban van-e}
   Kezd,Veg       : Word;
 end{record};

 TMenuSor = Object
   X1,Y1          : Integer; {Menu bal also sarkanak koordinatai}
   Irany          : Boolean; {Menupontok elhelyezkedese: 0:sorfolytonos, 1:oszlopfolytonos}

   AktivMRajzSzin : Word;    {Menu rajzolasi szine, ha kivalaszthato a menupont}
   PasszMRajzSzin : Word;   {Menu rajzolasi szine, ha nem kivalaszthato a menupont}

   AktualHSzin    : Word;    {Aktualis menupont hatterszine}
   NotAktualHSzin : Word;    {Nem aktualis menupont hatterszine}

   MenuKoz        : Word;    {Menupontok oszlopai vagy sorai kozotti tavolsag}
   HatarSavSzel   : Word;

   Constructor Konstruktor;
   Procedure AddMenuPont(MenuPont:TMenuPont);
   Function MenuRajz:Boolean;
   Function MenuReakcio(Bill:char;var MenuPont:Byte):Boolean;
   Function MenuMag:Word;
   Function MenuSzel:Word;
   Procedure MenuPontTerulet(Cimke:String;var MPX1,MPY1,MPX2,MPY2:Integer);

   Private
     MenuPontok   : Array[1..MaxSzam] of TMenuPont; {Menupontok adatai}
     MenuPontSzam : Byte;    {Menupontok szama}
     AktMenuPont  : Byte;    {Aktualis menu sorszama}
 end{Object};


IMPLEMENTATION


Constructor TMenuSor.Konstruktor;
 begin
   AktMenuPont:=0;
   MenuPontSzam:=0;
 end{Konstruktor};


Function TMenuSor.MenuMag:Word;
 var
   i   : Byte;
   Mag : Word;
 begin
   If Irany {oszlopfolytonos} Then
     Mag:=TextHeight('S')+(2*HatarSavSzel)
   Else  {sorfolytonos}
     begin
      Mag:=0;
      For i:=1 to MenuPontSzam do
        Mag:=Mag+TextHeight(MenuPontok[i].Cimke);
      Mag:=Mag+((MenuPontSzam+1)*MenuKoz) {kozok az elejere, vegere, es mindegyik koze};
     end{else};
   MenuMag:=Mag;
 end{MenuMag};


Function TMenuSor.MenuSzel:Word;
 function MaxKiv:Byte;
   var
     i  : Byte;
     Sv : Byte;
   begin
     Sv:=1;
     for i:=2 to MenuPontSzam do
       If TextWidth(MenuPontok[i].Cimke)>TextWidth(MenuPontok[Sv].Cimke)
       Then Sv:=i;
     MaxKiv:=Sv;
   end{MaxKiv};
 var
   i    : Byte;
   Szel : Word;
 begin{MenuSzel}
   If Irany {oszlopfolytonos} Then
     begin
       Szel:=0;
       For i:=1 to MenuPontSzam do
         Szel:=Szel+TextWidth(MenuPontok[i].Cimke);
       Szel:=Szel+((MenuPontSzam+1)*MenuKoz); {kozok az elejere, vegere, es mindegyik koze}
     end
   Else  {sorfolytonos}
     Szel:=TextWidth(MenuPontok[MaxKiv].Cimke)+(2*MenuKoz);
   MenuSzel:=Szel;
 end{MenuSzel};


Function TMenuSor.MenuRajz:Boolean;
 var
   i        : Byte;
   FillInfo : FillSettingsType;
   X        : Word;
 begin{MenuRajz}
   If (MenuMag>GetMaxY) or (MenuSzel>GetMaxX) Then
     Halt;
   GetFillSettings(FillInfo); {kitoltesi minta es szin elmentese}

   If Irany {oszlopfolytonos} Then
     begin
{      SetViewPort2(X1,Y1,X1+MenuSzel,Y1+MenuMag,True);}
      SetFillStyle(1,NotAktualHSzin); {kovetkezo kitoltesi minta betoltese}
{      ClearViewPort2;}
      X:=MenuKoz;
      For i:=1 to MenuPontSzam do
        begin
         If MenuPontok[i].AktivE Then   {menu rajzolasi szinenek beallitasa}
           SetColor(AktivMRajzSzin)
           Else SetColor(PasszMRajzSzin);
         OutTextXY2(X,HatarSavSzel,MenuPontok[i].Cimke);
         MenuPontok[i].Kezd:=X;
         MenuPontok[i].Veg:=X+TextWidth(MenuPontok[i].Cimke);
         X:=X+TextWidth(MenuPontok[i].Cimke)+MenuKoz;
        end{for}
     end{then}
   Else {sorfolytonos}
     begin

     end{else};
   SetFillStyle(FillInfo.Pattern,FillInfo.Color);{elozo kitoltesi minta visszaallitasa}
   MenuRajz:=True;
 end{MenuRajz};


Procedure TMenuSor.AddMenuPont(MenuPont:TMenuPont);
 begin
   Inc(AktMenuPont);
   MenuPontok[AktMenuPont]:=MenuPont;
   Inc(MenuPontSzam);
 end{MenuRajz};


Function TMenuSor.MenuReakcio(Bill:char;var MenuPont:Byte):Boolean;
 var
    FillInfo      : FillSettingsType;
    FelKoz        : Word;
    ElozoMenuPont : Byte;
    KeresMenuPont : Byte;
 begin
   GetFillSettings(FillInfo); {kitoltesi minta es szin elmentese}
   SetViewPort2(X1,Y1,X1+MenuSzel,Y1+MenuMag,True);
   AktMenuPont:=MenuPont;
   ElozoMenuPont:=AktMenuPont;
   MenuReakcio:=False;
   If Irany {oszlopfolytonos} Then
     begin
       FelKoz:=MenuKoz Div 2;
       ElozoMenuPont:=AktMenuPont;
       Case Bill of
         chr(13) : begin
                     MenuReakcio:=True;
                   end{chr(13)};
         chr(75) : begin
                     If AktMenuPont>1
                     Then KeresMenuPont:=AktMenuPont-1
                     Else KeresMenuPont:=MenuPontSzam;
                     While (AktMenuPont<>KeresMenuPont) and
                           (MenuPontok[KeresMenuPont].AktivE=false) do
                       begin
                         If KeresMenuPont>1
                         Then Dec(KeresMenuPont)
                         Else KeresMenuPont:=MenuPontSzam;
                       end{while};
                     AktMenuPont:=KeresMenuPont;
                   end{chr(75)};

         chr(77) : begin
                     If AktMenuPont<MenuPontSzam
                     Then KeresMenuPont:=AktMenuPont+1
                     Else KeresMenuPont:=1;
                     While (AktMenuPont<>KeresMenuPont) and
                           (MenuPontok[KeresMenuPont].AktivE=false) do
                       begin
                         If KeresMenuPont<MenuPontSzam
                         Then Inc(KeresMenuPont)
                         Else KeresMenuPont:=1;
                       end{while};
                     AktMenuPont:=KeresMenuPont;
                   end{chr(77)};
       end{case};
       MenuPont:=AktMenuPont;
       {Elozo menupont ujrarajzolasa}
       SetFillStyle(1,NotAktualHSzin); {kovetkezo kitoltesi minta betoltese}
       Bar2(MenuPontok[ElozoMenuPont].Kezd-FelKoz,0,MenuPontok[ElozoMenuPont].Veg+FelKoz,MenuMag);
       If MenuPontok[ElozoMenuPont].AktivE Then   {menu rajzolasi szinenek beallitasa}
         SetColor(AktivMRajzSzin)
         Else SetColor(PasszMRajzSzin);
       OutTextXY2(MenuPontok[ElozoMenuPont].Kezd,HatarSavSzel,MenuPontok[ElozoMenuPont].Cimke);

       {Aktiv menuont megrajzolasa}
       SetFillStyle(1,AktualHSzin); {kovetkezo kitoltesi minta betoltese}
       Bar2(MenuPontok[AktMenuPont].Kezd-FelKoz,0,MenuPontok[AktMenuPont].Veg+FelKoz,MenuMag);
       If MenuPontok[AktMenuPont].AktivE Then   {menu rajzolasi szinenek beallitasa}
         SetColor(AktivMRajzSzin)
         Else SetColor(PasszMRajzSzin);
       OutTextXY2(MenuPontok[AktMenuPont].Kezd,HatarSavSzel,MenuPontok[AktMenuPont].Cimke);
     end{then}
   Else  {sorfolytonos}
     begin
           Halt;
     end{else};
   SetFillStyle(FillInfo.Pattern,FillInfo.Color);{elozo kitoltesi minta visszaallitasa}
 end{MenuBekapcs};


Procedure TMenuSor.MenuPontTerulet(Cimke:String;var MPX1,MPY1,MPX2,MPY2:Integer);
 var
   SorSzam : Byte;
   i       : Byte;
 begin
   SorSzam:=1;
   While (SorSzam<=MenuPontSzam) and (Cimke<>MenuPontok[SorSzam].Cimke) do {kereses:}
     SorSzam:=SorSzam+1;
   If SorSzam>MenuPontSzam Then
     Halt
   Else
    begin  {terulet-meghatarozas:}
      If Irany {oszlopfolytonos} Then
        begin
          MPX1:=X1;
          For i:=1 to SorSzam-1 do
            MPX1:=MPX1+TextWidth(MenuPontok[i].Cimke);
          MPX1:=MPX1+((SorSzam-1)*MenuKoz)+HatarSavSzel+1; {kozok az elejere, vegere, es mindegyik koze}
          MPY1:=Y1;{ez helyben marad}
          MPX2:=MPX1+TextWidth(MenuPontok[SorSzam].Cimke);
          MPY2:=MPY1+TextHeight(MenuPontok[SorSzam].Cimke)+(2*HatarSavSzel);
        end{then}
      Else {sorfolytonos}
        begin

        end{else}
    end{else};
 end{MenuPontTerulet};

Begin

End.